# GridFire: PyEngine Class Reference

Loading...
Searching...
No Matches
PyEngine Class Referencefinal

`#include <py_engine.h>`

Inheritance diagram for PyEngine:

## Public Member Functions

const std::vector< fourdst::atomic::Species > & | getNetworkSpecies () const override
| Get the list of species in the network.
std::expected< gridfire::StepDerivatives< double >, gridfire::expectations::StaleEngineError > | calculateRHSAndEnergy (const std::vector< double > &Y, double T9, double rho) const override
| Calculate the right-hand side (dY/dt) and energy generation.
Public Member Functions inherited from gridfire::Engine
virtual | ~Engine ()=default
| Virtual destructor.

## Private Attributes

std::vector< fourdst::atomic::Species > | m_species_cache

## Detailed Description

Definition at line 12 of file py_engine.h.

## Member Function Documentation

## calculateRHSAndEnergy()

std::expected< gridfire::StepDerivatives< double >, gridfire::expectations::StaleEngineError > PyEngine::calculateRHSAndEnergy | ( | const std::vector< double > & | Y,
|  | double | T9,
|  | double | rho ) const

overridevirtual

Calculate the right-hand side (dY/dt) and energy generation.

Parameters

  Y | Vector of current abundances for all species.
  T9 | Temperature in units of 10^9 K.
  rho | Density in g/cm^3.

Returns
  StepDerivatives<double> containing dY/dt and energy generation rate.

This function must be implemented by derived classes to compute the time derivatives of all species and the specific nuclear energy generation rate for the current state.

Implements gridfire::Engine.

Definition at line 37 of file py_engine.cpp.

## getNetworkSpecies()

const std::vector< fourdst::atomic::Species > & PyEngine::getNetworkSpecies | ( |  | ) | const

overridevirtual

Get the list of species in the network.

Returns
  Vector of Species objects representing all network species.

Implements gridfire::Engine.

Definition at line 16 of file py_engine.cpp.

## Member Data Documentation

## m_species_cache

std::vector<fourdst::atomic::Species> PyEngine::m_species_cache

mutableprivate

Definition at line 17 of file py_engine.h.

The documentation for this class was generated from the following files:

- src/python/engine/trampoline/py_engine.h
- src/python/engine/trampoline/py_engine.cpp